/*
 * Created on 17-Jul-2003
 */
package events;

import appia.AppiaEventException;
import appia.Channel;
import appia.Session;
import appia.events.SendableEvent;
import appia.message.ExtendedMessage;

/**
 * Sendable Event used by the application.
 * @author nuno
 */
public class SampleSendableEvent extends SendableEvent {

	private String command;
	
	/**
	 * Default constructor.
	 */
	public SampleSendableEvent() {
		super(new ExtendedMessage());
	}

	/**
	 * Constructor if the event.
	 * @param channel The Appia channel.
	 * @param dir The direction of the event.
	 * @param source The session that created the event.
	 * @throws AppiaEventException
	 */
	public SampleSendableEvent(Channel channel, int dir, Session source)
		throws AppiaEventException {
		super(channel, dir, source);
	}

	/**
	 * Constructor of the event.
	 * @param msg The message to use.
	 */
	public SampleSendableEvent(ExtendedMessage msg) {
		super(msg);
	}

	/**
	 * Constructor of the event.
	 * @param channel The Appia channel.
	 * @param dir The direction of the event.
	 * @param source The session that created the event.
	 * @param msg The message to use.
	 * @throws AppiaEventException
	 */
	public SampleSendableEvent(
		Channel channel,
		int dir,
		Session source,
		ExtendedMessage msg)
		throws AppiaEventException {
		super(channel, dir, source, msg);
	}

	/**
	 * @return Returns the command.
	 */
	public String getCommand() {
		return command;
	}

	/**
	 * @param command The command to set.
	 */
	public void setCommand(String command) {
		this.command = command;
	}

}
