/*
 * Created on 28-Jul-2003
 */
package protocols.perfectFailureDetector;

import events.*;
import events.ProcessInitEvent;
import appia.Layer;
import appia.Session;
import appia.events.channel.ChannelInit;
import appia.protocols.tcpcomplete.TcpUndeliveredEvent;

/**
 * Layer of the Perfect Failure Detector. 
 * @author nuno
 */
public class PerfectFailureDetectorLayer extends Layer {

	public PerfectFailureDetectorLayer(){
		/* events that the protocol will create */
		evProvide = new Class[2];
		evProvide[0] = Crash.class;
		evProvide[1] = CreateChannelsEvent.class;
	
		/* events that the protocol require to work.
		 * This is a subset of the accepted events */
		evRequire = new Class[4];
		evRequire[0] = TcpUndeliveredEvent.class;
		evRequire[1] = ChannelInit.class;
		evRequire[2] = ProcessInitEvent.class;
		evRequire[3] = PFDStartEvent.class;
	
		/* events that the protocol will accept */
		evAccept = new Class[5];
		evAccept[0] = TcpUndeliveredEvent.class;
		evAccept[1] = ChannelInit.class;
		evAccept[2] = ProcessInitEvent.class;
		evAccept[3] = CreateChannelsEvent.class;
		evAccept[4] = PFDStartEvent.class;
	}


	/**
	 * Creates a new session to this protocol.
	 * @see appia.Layer#createSession()
	 */
	public Session createSession() {
		return new PerfectFailureDetectorSession(this);
	}

}
