/*
 * Created on 21-Jul-2003
 */
package protocols.sampleAppl;

import java.util.StringTokenizer;

import appia.Direction;
import appia.message.ExtendedMessage;
import events.SampleSendableEvent;

/**
 * Class that reads from the keyboard and generates events to the appia Channel.
 * @author nuno
 */
public class SampleApplReader extends Thread {

	private SampleApplSession parentSession;
	private java.io.BufferedReader keyb;
	private String local = null;

	public SampleApplReader(SampleApplSession parentSession) {
		super();
		this.parentSession = parentSession;
		keyb =
			new java.io.BufferedReader(
				new java.io.InputStreamReader(System.in));
	}

	public void run() {
		while (true) {
			try {
				System.out.print("> ");
				local = keyb.readLine();
				if(local.equals(""))
					continue;
				StringTokenizer st = new StringTokenizer(local);
				/* creates the event, push the message and sends this to the appia channel. */
				SampleSendableEvent asyn = new SampleSendableEvent();
				ExtendedMessage message = (ExtendedMessage) asyn.getMessage();
				asyn.setCommand(st.nextToken());
				String msg = "";
				while(st.hasMoreTokens())
					msg += (st.nextToken() + " ");
				message.pushString(msg);
				asyn.asyncGo(
					parentSession.channel,
					Direction.DOWN);
			} catch (java.io.IOException e) {
				e.printStackTrace();
			} catch (appia.AppiaEventException e) {
				e.printStackTrace();
			}
		}
	}
}
