/*
 * URBLayer.java
 * Created on 19-Sep-2003, 11:34:14
 */
package protocols.uniformReliableBroadcast;

import events.Crash;
import events.ProcessInitEvent;
import appia.Layer;
import appia.Session;
import appia.events.SendableEvent;
import appia.events.channel.ChannelClose;
import appia.events.channel.ChannelInit;

/**
 * Class URBLayer. Layer of the Best Effort Broadcast protocol. 
 * @author nuno
 */
public class URBLayer extends Layer {

	public URBLayer(){
		/* events that the protocol will create */
		evProvide = new Class[0];
	
		/* events that the protocol require to work.
		 * This is a subset of the accepted events */
		evRequire = new Class[4];
		evRequire[0] = SendableEvent.class;
		evRequire[1] = ChannelInit.class;
		evRequire[2] = ProcessInitEvent.class;
		evRequire[3] = Crash.class; 

		/* events that the protocol will accept */
		evAccept = new Class[5];
		evAccept[0] = SendableEvent.class;
		evAccept[1] = ChannelInit.class;
		evAccept[2] = ChannelClose.class;
		evAccept[3] = ProcessInitEvent.class;
		evAccept[4] = Crash.class;
	}

	/**
	 * Creates a new session to this protocol.
	 * @see appia.Layer#createSession()
	 */
	public Session createSession() {
		return new URBSession(this);
	}

}
